zorilla/zorilla/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path("admin/", admin.site.urls),
    path("api/", include("zorilla_api.urls", namespace="api")),
    path("web/", include("zorilla_web.urls", namespace="web")),
    path("web/shib/", include("shibboleth.urls", namespace="shibboleth")),
]

zorilla/zorilla_web/urls.py
from django.urls import path, include
from django.contrib.auth.decorators import login_required
from jchart.views import ChartView
from zorilla_web.charts import FsQuotaChart
from zorilla_web.views import *

app_name = "zorilla-web"

urlpatterns = [
    path("", IndexView.as_view(), name="index"),
    path("dashboard/", DashboardView.as_view(), name="dashboard"),
    path("user/profile/", UserProfileView.as_view(), name="user_profile"),
    path(
        "filesystem/<int:fs_id>/edit/",
        FilesystemEditView.as_view(),
        name="filesystem_edit",
    ),
    path(
        "charts/fs_quota/<int:fs_id>/",
        login_required(ChartView.from_chart(FsQuotaChart())),
        name="fs_quota_chart",
    ),
]

zorilla/zorilla_web/models.py
from django.db import models

zorilla/zorilla_web/forms.py
from django import forms
from django.conf import settings
from django.core.validators import RegexValidator
from django.utils.translation import ugettext_lazy
from zorilla_web.validators import validate_snapshot_retention, validate_filesystem_name


class ZFilesystemForm(forms.Form):
    group_id = forms.ChoiceField(
        label=ugettext_lazy("Group access"),
        help_text=ugettext_lazy("Members of this group will have access to the share."),
    )
    snapshot_retention = forms.ChoiceField(
        label=ugettext_lazy("Snapshot retention days"),
        help_text="{} {}".format(
            ugettext_lazy("Number of days to keep backup snapshots."),
            ugettext_lazy("Space used by snapshots counts against your overall quota."),
        ),
        choices=[(c, c) for c in settings.SNAPSHOT_RETENTION_VALUES],
        validators=[validate_snapshot_retention],
    )


class SelfProvisionForm(forms.Form):
    filesystem_name = forms.CharField(
        label=ugettext_lazy("Share name"),
        help_text=ugettext_lazy(
            "The name must contain only lowercase alphanumeric characters ('a-z0-9'), hyphens ('-'), and underscores ('_')"
        ),
        widget=forms.TextInput(attrs={"id": "filesystem_name"}),
        validators=[
            RegexValidator(
                regex="^[a-z0-9_-]+$", message=ugettext_lazy("Invalid characters")
            ),
            validate_filesystem_name,
        ],
    )
    group_id = forms.ChoiceField(
        label=ugettext_lazy("Group access"),
        help_text=ugettext_lazy("Members of this group will have access to the share."),
    )
    share_smb = forms.BooleanField(
        initial=True, required=False, widget=forms.HiddenInput()
    )
    share_nfs = forms.BooleanField(
        initial=False, required=False, widget=forms.HiddenInput()
    )

zorilla/zorilla_web/views.py
from django.conf import settings
from django.contrib import messages
from django.contrib.auth.mixins import LoginRequiredMixin
from django.core.exceptions import PermissionDenied
from django.utils.translation import ugettext
from django.views.generic import TemplateView, View
from django.views.generic.edit import FormView
from django.shortcuts import redirect, render
from django.urls import reverse
from django.utils.decorators import method_decorator
from django.views.decorators.cache import never_cache
from zorilla_core.models import ZFilesystem, ZSnapshot
from zorilla_web.functions import (
    get_fsid_from_path,
    get_group_id_choices,
    get_filesystem,
    get_filesystem_form,
    get_self_provision_form,
    get_user_filesystems,
    provision_filesystem,
    provision_group_change,
    provision_backup,
    set_profile,
)
from zorilla_web.forms import SelfProvisionForm, ZFilesystemForm


class IndexView(TemplateView):
    def page_title(self):
        """
        Render page title for template
        """
        return ugettext("Main")

    def get(self, *args, **kwargs):
        if self.request.user.is_authenticated:
            return redirect("web:dashboard")
        else:
            return render(
                self.request,
                template_name="zorilla_web/index.html",
                context={"view": self},
            )


@method_decorator(never_cache, name="dispatch")
class DashboardView(LoginRequiredMixin, TemplateView):
    def page_title(self):
        """
        Render page title for template
        """
        return ugettext("Dashboard")

    def filesystems(self):
        """
        Render filesystem list for template
        """
        return get_user_filesystems(self.request.user)

    def get(self, *args, **kwargs):
        form = get_self_provision_form(self.request.user)
        return render(
            self.request,
            template_name="zorilla_web/dashboard.html",
            context={"form": form, "view": self},
        )

    def post(self, request, **kwargs):
        form = SelfProvisionForm(request.POST)
        form.fields["group_id"].choices = get_group_id_choices(
            request.user, initial_choice=None
        )
        if form.is_valid():
            if request.user.userprofile.self_provisioned == False:
                provision_filesystem(request.user, form.cleaned_data)
                set_profile(request.user, "self_provisioned", True)
                messages.success(
                    request,
                    ugettext(
                        "Your share is being provisioned. Please reload this page in a few minutes."
                    ),
                )
            else:
                messages.error(
                    request, ugettext("The user share was already provisioned")
                )
        else:
            messages.error(request, form.errors)
        return redirect(reverse("web:dashboard"))


class FilesystemEditView(LoginRequiredMixin, View):
    def page_title(self):
        return ugettext("Edit Filesystem")

    def get(self, *args, **kwargs):
        filesystem = get_filesystem(kwargs["fs_id"])
        form = get_filesystem_form(self.request.user, filesystem)
        return render(
            self.request,
            template_name="zorilla_web/filesystem_edit.html",
            context={"filesystem": filesystem, "form": form, "view": self},
        )

    def post(self, request, **kwargs):
        form = ZFilesystemForm(request.POST)
        filesystem_id = get_fsid_from_path(request.path)
        filesystem = get_filesystem(filesystem_id)
        form.fields["group_id"].choices = get_group_id_choices(
            request.user, initial_choice=filesystem.group_id
        )
        if form.is_valid():
            provision_group_change(filesystem_id, form.cleaned_data)
            provision_backup(self.request.user, filesystem_id, form.cleaned_data)
            messages.success(request, ugettext("Changes submitted!"))
            return redirect(reverse("web:dashboard"))
        else:
            messages.error(request, form.errors)
            return redirect("web:filesystem_edit", fs_id=kwargs["fs_id"])


class UserProfileView(LoginRequiredMixin, TemplateView):
    template_name = "zorilla_web/user_profile.html"

    def page_title(self):
        """
        Render page title for template
        """
        return ugettext("Profile")

zorilla/zorilla_web/templates/zorilla_web/dashboard.html
{% extends 'zorilla_web/wrapper.html' %}
{% load i18n %}
{% load static %}
{% load mathfilters %}
{% load jchart %}
{% load unit_conversion %}
{% load ldap_search %}
{% load bootstrap4 %}

{% block content %}
  <h2>
    {% trans 'My Storage' %}
  </h2>
  <div id="my_storage_list">
    {% if view.filesystems|length == 0 %}
      {% trans 'You do not currently have any filesystems to manage.' %}
    {% else %}
      {% for f in view.filesystems %}
        <div class="filesystem">
          <div class="edit_link">
            [<a href="{% url 'web:filesystem_edit' f.id %}">edit</a>]
          </div>
          <div class="donut_chart">
            {% render_chart 'web:fs_quota_chart' f.id %}
          </div>
          <h4>
            {{ f.fsname | upper }}
          </h4>
          <div id="storage-list-grid">
            <div class="grid-left">{% trans 'Server' %}</div> <div class="grid-right">{{ f.hostname }}</div>
            {% if f.sharesmb %}
            <div class="grid-left">{% trans 'Windows Share' %}</div> <div class="grid-right">\\{{ f.hostname }}\{{ f.smb_sharename }}</div>
            {% endif %}
            {% if f.sharenfs %}
            <div class="grid-left">{% trans 'NFS Share' %}</div> <div class="grid-right">{{ f.hostname }}:/{{ f.zpool }}/{{ f.fsname }}</div>
            {% endif %}
            <div class="grid-left">{% trans 'Owner' %}</div> <div class="grid-right">{{ f.owner_id | ldap_user_name }}</div>
            <div class="grid-left">{% trans 'Group' %}</div> <div class="grid-right">{{ f.group_id | ldap_group_name }}</div>
            <div class="grid-left">{% trans 'Quota' %}</div> <div class="grid-right">{{ f.refquota_bytes|bytes_to_gbytes|floatformat:1 }} GB</div>
            <div class="grid-left">{% trans 'Used' %}</div> <div class="grid-right">{{ f.used_bytes|bytes_to_gbytes|floatformat:1 }} GB</div>
            <div class="grid-left">{% trans 'Free' %}</div> <div class="grid-right">{{ f.refquota_bytes|sub:f.used_bytes|bytes_to_gbytes|floatformat:1 }} GB</div>
            <div class="grid-left">{% trans 'Snapshots' %} ({{ f.snapshots | length }})</div>
            <div id="snapshot-show" class="grid-right">
                <input type="checkbox" name="toggle-snapshots"> {% trans 'Show list' %}
            </div>
            <div class="grid-left"></div>
            <div id="snapshot-list" class="hidden">
              <div class="snapshot-list-grid">
                {% for snap in f.snapshots %}
                  <div>
                    {{ snap.name }}
                  </div>
                {% endfor %}
              </div>
            </div>
          </div>
        </div>
      {% endfor %}
    {% endif %}
  </div>
  <div id="self_provision_form">
    {% if request.user.userprofile.self_provisioned == False %}
      <p>
        Please use the form below to create a new network share.
      </p>
      <div id="self_provision_form">
        <form method="POST" action="{% url 'web:dashboard' %}" class="form">
          {% csrf_token %}
          {% bootstrap_form form %}
          {% buttons %}
          <button type="submit" class="btn btn-primary">
            {% trans 'Provision' %}
          </button>
          {% endbuttons %}
        </form>
      </div>
    {% endif %}
  </div>
  <script src='{% static "zorilla_web/js/Chart.bundle.min.js" %}' /></script>
  <script type="text/javascript">
    $(function()
      {
        $('[name="toggle-snapshots"]').change(function()
          {
            current_item = $(this).parent().parent()
            if ($(this).is(':checked')) {
              current_item.children("#snapshot-list").removeClass("hidden");
            }
            else {
              current_item.children("#snapshot-list").addClass("hidden");
            };
          });
        });
  </script>
{% endblock %}

zorilla/zorilla_web/templates/zorilla_web/filesystem_edit.html
{% extends 'zorilla_web/wrapper.html' %}
{% load i18n %}
{% load bootstrap4 %}

{% block content %}
  <h2>
    {% trans 'Edit Filesystem' %}: {{ filesystem.fsname | upper }}
  </h2>
  <div id="edit_filesystem">
    <form method="POST" action="{% url 'web:filesystem_edit' filesystem.id %}" class="form">
      {% csrf_token %}
      {% bootstrap_form form %}
      {% buttons %}
      <button type="submit" class="btn btn-primary">
        {% trans 'Save' %}
      </button>
      {% endbuttons %}
    </form>
  </div>
{% endblock %}

zorilla/zorilla_web/templates/zorilla_web/index.html
{% extends 'zorilla_web/wrapper.html' %}
{% load i18n %}
{% load static %}

{% block content %}
  Please log in.
{% endblock %}

zorilla/zorilla_web/templates/zorilla_web/user_profile.html
{% extends 'zorilla_web/wrapper.html' %}
{% load i18n %}
{% load ldap_search %}

{% block content %}
  <h2>{% trans 'My Profile' %}</h2>
  <div id="user_profile">
    <div class="flex-row">
      <div class="label-column">
        <ul>
            <li>Name</li>
            <li>Email</li>
            <li>API Token</li>
        </ul>
      </div>
      <div class="value-column">
        <ul>
          <li>{{ request.user.userprofile.full_name }}</li>
          <li>{{ request.user.email | lower }}</li>
          <li>{{ request.user.auth_token.key }}</li>
        </ul>
      </div>
    </div>
  </div>
{% endblock %}

zorilla/zorilla_web/templates/zorilla_web/wrapper.html
<!DOCTYPE html>
{% load static %}
{% load i18n %}
{% load bootstrap4 %}
<html>
    <head>
        <meta charset="utf-8">
        <title>{{ app_name }} | {{ view.page_title }}</title>
        <link rel="shortcut icon" type="image/png" href="{% static 'zorilla_web/img/favicon.ico' %}"/>
        <link rel="stylesheet" type="text/css" href='{% static "zorilla_web/css/bootstrap.min.css" %}'/>
        <link rel="stylesheet" type="text/css" href='{% static "zorilla_web/css/main.css" %}'/>
        <script src='{% static "zorilla_web/js/bootstrap.min.js" %}' /></script>
        <script src='{% static "zorilla_web/js/popper.min.js" %}' /></script>
        <script src='{% static "zorilla_web/js/jquery-3.5.1.min.js" %}' /></script>
        {% bootstrap_messages %}
    </head>

    <body>
      <div id="home">
        <header>
            <div id="right-header-menu">
                {% if request.user.is_authenticated and request.user.groups_checked %}
                  <div class="username">
                    {{ request.user.last_name }}, {{ request.user.first_name }}
                  </div>
                {% endif %}
                <ul>
                  {% if request.user.is_authenticated %}
                    <!-- <li><a href="{{logout_link}}">{% trans 'Logout' %}</a></li> -->
                  {% else %}
                    <li><a href="{{login_link}}">{% trans 'Login' %}</a></li>
                  {% endif %}
                </ul>
            </div>

            <div id="header-content">
                <a href="/"><img id="header-image" src="{{ logo_url }}"></a> {{ app_name }}
            </div>
        </header>

        <div id="menu" class="uppercase hidden">
           <ul>
             {% if request.user.is_authenticated and request.user.groups_checked %}
                <li><a href="{% url 'web:dashboard' %}" title="{% trans 'Dashboard' %}">{% trans 'Dashboard' %}</a></li>
                <li><a href="{% url 'web:user_profile' %}" title="{% trans 'Profile' %}">{% trans 'Profile' %}</a></li>
             {% endif %}
           </ul>
        </div>

        <div id="content">
            {% block content %}
            {% endblock %}
        </div>

        <footer id="footer">
            <div id="footer-content" class="centered">
                 <a href="https://gitlab.uvm.edu/saa/research-storage-automation/zorilla">zorilla</a>
                 <a href="https://uvm.edu" target="_blank">© 2019 University of Vermont</a>
            </div>
        </footer>
      </div>
    </body>
    {% if request.user.is_authenticated %}
    <script type="text/javascript">
        $("#menu").removeClass("hidden");
    </script>
    {% endif %}
</html>